function plotInstantAgents(agent_list, obstacle_list, t, h_instant, time, axis_array)

lineWidthSmall = 0.5;
lineWidthBig = 2;
fontSizeSmall = 14;
fontSizeBig = 20;

global database;

hold on

%% Plot all agents
for jj = 1:length(agent_list)
    agent_list(jj).plot_agent(t, h_instant, lineWidthSmall, lineWidthBig, agent_list(jj).get_d_safe(), ['r', 'w']);
    
    % Plot sensor disk
%     disk_center = agent_list(jj).get_sensor_disk_center(database.obstacleSenseDistance, t);
%     ang=0:0.01:2*pi;
%     r = database.obstacleSenseDistance/2;
%     x_disk = r *cos(ang) + disk_center(1);
%     y_disk = r *sin(ang) + disk_center(2);
%     hSenseDisk = plot(y_disk, x_disk, 'Color', 'k', 'LineStyle', ':');
%     set(hSenseDisk,'LineWidth', 0.7);
end

%% Plot obstacle
for ii = 1:length(obstacle_list)
    obstacle_list(ii).plot_agent(t, h_instant, lineWidthSmall, lineWidthBig, obstacle_list(ii).get_d_safe(), ['b', 'w']);
end
 

%% Set title
hTitle = title(['time: ' num2str(time.get_time(t))]);
set(hTitle,'FontSize',fontSizeBig,'FontName','Times');

%% Set labels
hXLabel = xlabel('y [m]');
set(hXLabel,'FontSize',fontSizeBig,'FontName','Times');
hYLabel = ylabel('x [m]');
set(hYLabel,'FontSize',fontSizeBig,'FontName','Times');


%% Set axis font size and linewidth
h = gca;
set(h,'FontSize',fontSizeSmall);
set(h,'LineWidth',lineWidthSmall);

axis(axis_array);
end