function [ ship_corners ] = plot_ship( eta )
%Returns points to plot the ship

w = 0.75;
l = 6/1.2;

x = eta(1);
y = eta(2);
psi = eta(3);

p = [x;y];

R = Rzyx(0,0,psi);
R = R(1:2,1:2);

p11 = [1.2*l;0];
p21 = [l;w];
p31 = [-l;w];
p41 = [-l;-w];
p51 = [l;-w];

center_point = [0.6*l;0];

p1 = R*(p11-center_point) + p;
p2 = R*(p21-center_point) + p;
p3 = R*(p31-center_point) + p;
p4 = R*(p41-center_point) + p;
p5 = R*(p51-center_point) + p;

ship_corners = [p1,p2,p3,p4,p5,p1];


end

