function [Vnew, cluttered] = choose_new_v(agent, Vd, rvo_list, t)
% Find new velocity outside rvo and as close as possible to [speed_d, psi_d]

cur_pos = agent.state(1:2,t);
cur_psi = agent.state(3,t);
cur_V = agent.state_dot(1:2,t-1);
Vmax = agent.get_max_speed();
Vmin = agent.get_min_speed();
cluttered = 0;

%plot_all_velo_candidates(cur_pos, Vd, 'b', 5)


% Make a set of N v's that is within acc and yaw_max constraints. 
psi_delta = 0.1; psi_range = 0.5;
speed_delta = 0.1; 
speed_range = 0.6;
a_list = find_V_candidates(psi_range, psi_delta, speed_range, speed_delta, rvo_list, cur_pos, cur_V, Vmin, Vmax);


if isempty(a_list)
    psi_delta = 0.05; psi_range = 1;
    speed_delta = 0.1; 
    speed_range = 1;
    a_list = find_V_candidates(psi_range, psi_delta, speed_range, speed_delta, rvo_list, cur_pos, cur_V, Vmin, 0.6*Vmax);
end

if isempty(a_list)
   % Do a more crude search for new V here 
    psi_delta = 0.15; psi_range = 1.5;
    speed_delta = 0.2; 
    speed_range = 1.5;
    a_list = find_V_candidates(psi_range, psi_delta, speed_range, speed_delta, rvo_list, cur_pos, cur_V, Vmin, Vmin+0.1);
end


if isempty(a_list)
    %disp('a_list er tom i find_best_velo()')
    %plot_all_velo_candidates(current_position, b_list, 'c')
    stop = 1;
    last_r = sum(agent.state(4,t-2:t));
    if last_r > 0
        [Vx, Vy] = pol2cart(cur_psi + 0.2, Vmin);
    else
        [Vx, Vy] = pol2cart(cur_psi - 0.2, Vmin);
    end
    a_list = [Vx; Vy];
    cluttered = 1;
    
    % Prve  se om jeg kan regne ut time to collision i stedet
    
    %dist = dist_to_line([yv, xv], [y, x], c_obs)
    % Velge laveste hastighet med strst dist til nrmeste obst
    % dist_to_line gir avstand fra punkt til linjestykke, jeg m derfor
    % lage en relativt lang ray i retning 2*Vnew - Va - Vb (tatt fra paper)
    % fra agent og deretter se p avstand til obst pos. Her kan jeg ogs se
    % p hvordan jeg har lst det i get_Ms
end


% Choose Vnew closest to Vd among candidates
%plot_all_velo_candidates(cur_pos, a_list,'m', 1);
V_cand = a_list - Vd;
%V_cand = a_list - cur_V;
mag = Inf;
index = 0;
for k = 1:size(a_list,2)
    Vlen = norm(V_cand(:,k));
    if Vlen < mag
        index = k;
        mag = Vlen;
        Vlist = a_list(:,k);
    elseif Vlen == mag
        Vlist = [Vlist a_list(:,k)];
    end
end

% Choose to turn most rightwards if there are more V candidates
Vnew = Vlist(:,1);
minAng = Inf; 
for kk = 2:size(Vlist,2)
    v2 = Vlist(:,kk);
    angle = atan2(cur_V(2),cur_V(1)) - atan2(v2(2),v2(1));
    if abs(angle) > pi
        angle = angle - 2*pi*sign(angle);
    end

    if angle < minAng
        minAng = angle;
        Vnew = Vlist(:,kk);
    end
end

%plot_all_velo_candidates(cur_pos, Vnew, 'g', 3)
end