classdef cone < handle
    % General class for handling obstacles.
    properties
        
    end
    
    properties (Access = protected)
        angles = [0;0];
        apex = [0;0];
    end
    
    methods (Access = public)
        function obj = cone(apex, angles)
            if(nargin>0)
                obj.angles = angles;
                obj.apex = apex;
            end
        end
        
        % Return the edge angles
        function angles = get_angles(obj)
            angles = obj.angles;
        end
        
        % Return apex
        function apex = get_apex(obj)
            apex = obj.apex;
        end

        
        %%%
        % Velocity is inside cone
        %%%
        function inside = is_inside(obj, pos, v)
            % Calc end pos of velo vector
            endpos = pos + v;
            %plot(endpos(2), endpos(1),'*')
            
            % Get angle from endpos to obj apex
            apex_pos = obj.get_apex();
            ang = vector_ang(apex_pos, endpos);
            
            % Check if ang is inside obj angles
            angs = obj.get_angles();
            inside = 0;
            if angs(2) > angs(1)
                if ang > angs(2) || ang < angs(1)
                    inside = 1;
                end
            elseif ang < angs(1) && ang > angs(2)
                inside = 1;
            end
        end
        
    end
    
    methods (Access=protected)
        
    end
end