function A = find_V_candidates(range_psi, delta_psi, range_speed, delta_speed, rvo_list, pos, V, Vmin, Vmax)

[psi,speed] = cart2pol(V(1), V(2));
A = [];

speed_max = speed + range_speed;
if speed_max > Vmax
    speed_max = Vmax;
end

speed_min = speed - range_speed;
if speed_min < Vmin
    speed_min = Vmin;
end

speed_grid = speed_min:delta_speed:speed_max;
psi_grid = -range_psi:delta_psi:range_psi;


for i = 1:length(psi_grid)
  psiNew = psi + psi_grid(i);
  for j = 1:length(speed_grid)
      [Vx, Vy] = pol2cart(psiNew, speed_grid(j));
      
      conflict = 0;
      for k = 1:length(rvo_list)
         if rvo_list(k).is_inside(pos, [Vx; Vy])
             conflict = 1;
             break;
         end
      end
            
      if conflict == 0
         A = [A [Vx; Vy]];
      end
  end
end


end