function [Vnew, cluttered] = find_best_velo(agent, Vd, rvo_list, t, time_step)
% Find new velocity outside rvo and as close as possible to [speed_d, psi_d]

cur_pos = agent.state(1:2,t);
cur_V = agent.state_dot(1:2,t-1);
[psi,speed] = cart2pol(cur_V(1), cur_V(2));
Vmax = agent.get_max_speed();
Vmin = agent.get_min_speed();
cluttered = 0;
a_list = [];
cand_list =[];

%plot_all_velo_candidates(cur_pos, Vd, 'b', 5)


% Make a set of N v's that is within acc and yaw_max constraints. 
r_max = agent.get_max_yaw_rate()*time_step;
a_max = agent.get_max_acc();
s1 = a_max; s2 = a_max;
if speed + a_max > Vmax
    s2 = 0;
end
if speed - a_max < Vmin
    s1 = 0;
end
    
speed_grid = -a_max:a_max/2:a_max;
psi_grid = -r_max:r_max/2:r_max;


for i = 1:length(psi_grid)
  psiNew = psi + psi_grid(i);
  for j = 1:length(speed_grid)
      [Vx, Vy] = pol2cart(psiNew, speed + speed_grid(j));
      cand_list = [cand_list [Vx; Vy]];
      
      conflict = 0;
      for k = 1:length(rvo_list)
         if rvo_list(k).is_inside(cur_pos, [Vx; Vy])
             conflict = 1;
             break;
         end
      end
            
      if conflict == 0
         a_list = [a_list [Vx; Vy]];
      end
  end
end
plot_all_velo_candidates(cur_pos, a_list,'m', 1);


if isempty(a_list)
    %disp('a_list er tom i find_best_velo()')
    cluttered = 1;
    
    % Ray in dir 2*Vnew - Va - Vb
    V1 = 2*cand_list(1,:) - V - Vb;
    
    % Prve  se om jeg kan regne ut time to collision i stedet
    
    %dist = dist_to_line([yv, xv], [y, x], c_obs)
    % Velge laveste hastighet med strst dist til nrmeste obst
    % dist_to_line gir avstand fra punkt til linjestykke, jeg m derfor
    % lage en relativt lang ray i retning 2*Vnew - Va - Vb (tatt fra paper)
    % fra agent og deretter se p avstand til obst pos. Her kan jeg ogs se
    % p hvordan jeg har lst det i get_Ms
end


% Choose Vnew closest to Vd among candidates
%plot_all_velo_candidates(cur_pos, a_list,'m', 1);
%V_cand = a_list - Vd;
V_cand = a_list - cur_V;
mag = Inf;
index = 0;
for k = 1:size(a_list,2)
    Vlen = norm(V_cand(:,k));
    if Vlen < mag
        index = k;
        mag = Vlen;
        Vlist = a_list(:,k);
    elseif Vlen == mag
        Vlist = [Vlist a_list(:,k)];
    end
end

% Choose to turn most rightwards if there are more V candidates
Vnew = Vlist(:,1);
minAng = Inf; 
for kk = 2:size(Vlist,2)
    v2 = Vlist(:,kk);
    angle = atan2(cur_V(2),cur_V(1)) - atan2(v2(2),v2(1));
    if abs(angle) > pi
        angle = angle - 2*pi*sign(angle);
    end

    if angle < minAng
        minAng = angle;
        Vnew = Vlist(:,kk);
    end
end

%plot_all_velo_candidates(cur_pos, Vnew, 'g', 3)
end