clear all;
close all;
clc;

addpath('Plotting');
addpath('obstacles');
addpath('RVO');

global database;


%% Initialize global variables;

database.obstacleSafetyDistance = 1;
database.obstacleSenseDistance = 7; % 8 was used in prosjektoppgave
database.sensor_res = 0.04;        % Sensor resolution in radians
D_rvo = 0.5;
MIN_SPEED = 0.4;                % Percentage of max speed


%% Time variables
time_start = 0;
time_stop = 150;
time_step = 0.05;
time=sim_time(time_start, time_stop, time_step);


%% Plotting
% Plot an instant each Nth time step (typically 5 for movie making, 50 for
plot_time_step = 5;

% Setup movie making
frame_count = ceil(time.get_sample_count()/plot_time_step);
movie_frames = struct('cdata',[],'colormap',[]);

%% Initialize agents and obstacles
%scObst;
scAgent;
%scMonte;

%% Run simulation

%do_sim_RVO;
do_sim;
%plot_min_dist_between_agents;
%plot_min_dist_to_obst;
do_plot_sim6;
hold off;

