function agent_list = generate_agents(params, init_list, t)
% init_list is structured like this:
% (x, y, psi, x_dot, y_dot, psi_dot, radius, speed, max_yaw_rate)
% where state = [x, y, psi]

len = size(init_list,1);
agent_list = [];

for i = 1:len
    agent = kinematic_agent(t, params(i,3), params(i,4), [params(i,1), params(i,2)]', params(i,5), params(i,6));
    agent.set_initial_conditions(init_list(i,1:4), init_list(i,5:8))
    agent_list = [ agent_list; agent ];
end

end